#define _GNU_SOURCE
#include <stdio.h>
#include <sys/types.h>
#include <syscall.h>
#include <sched.h>
#include <errno.h>
#include <stdlib.h>

//#define getcpu() syscall(SYS_getcpu)
#include <asm/vsyscall.h>
int getcpu(void)
{
	int (*getcpu_ptr)(void);

	getcpu_ptr = (int (*)(void)) VSYSCALL_ADDR(__NR_vgetcpu);
	fprintf(stderr, "calling getcpu at address: 0x%lx\n", getcpu_ptr);
	return getcpu_ptr();
}

int
main(int argc, char **argv)
{
	int ret;
	cpu_set_t  set;

	CPU_ZERO(&set);
	CPU_SET(1, &set);
	ret = sched_setaffinity(0, sizeof(cpu_set_t), &set);
	if (ret) {
		fprintf(stderr, "error setting affinity: %s",
			strerror(errno));
		exit(-1);
	}
	printf("cpu == %d\n", getcpu());
}
